#! /usr/local/bin/perl
#
# @(#) ƻ֥ǡ plain format V.0 Ѵ
#
# $RCSfile$  $Revision$
# $Date$  by KyotoHydro
#

# plain format V.0 ΥǡʬѰդƤȤˡ
# plain format V.0 Υǡ뤿ΥץǤ

# ǡplain format V.0 ΥǡʬѰդƤȤΤϡ
# [Data] ʬѰդƤ뤳Ȥ̣ޤ[Data] ʬǡ
# Ǹ2ĤΥǡ
#
#     ƻʬֹ, üΰ־
#
# ϡפǤäƤ̵뤵졤Υץޤ
# [Data] ʬȤȤ[Data] Ƚ񤤤Ԥϴޤߤޤ

sub usage {
    if ($0 =~ m#.*/([^/]*)$#) {
        $0 = $1
    };
    print "usage: $0 orginalFileName outputFileName\n";
    exit 1;
}

if ($#ARGV != 1)
{
  # $#ARGV ϡ0Ϥ᤿θĿ
  &usage;
}

# ˤʤƻ֥ǡåȤ̾
$originalFileName = $ARGV[0];

# ΥץबformatΥե̾
$outputFileName = $ARGV[1];

# ˺ե˥Ȥ񤭹
open(OFILE, ">$outputFileName") || die "$outputFileName : $!";
print OFILE <<"EOF";
# @(#) dataset of a channel network
# $outputFileName
# produced by changeToV0Format.pl from $originalFileName
#
EOF

# ɸϤ̾Τ䤤碌
print OFILE "[Data Format Name]\n";
print OFILE "plain format V.0\n";

# ɸϤ̾Τ䤤碌
print "Input Coordinate System: ";
chomp($coordinateSystem = <STDIN>);
print OFILE "[Coordinate System]\n";
print OFILE $coordinateSystem, "\n";

# ޳ֹ䤤碌
print "Input Map Number: (example: 1 2) ";
chomp($line = <STDIN>);
@list = split(' ', $line);
print OFILE "[Map Number]\n";
$xMap = $list[0];
$yMap = $list[1];
print OFILE $xMap, " ", $yMap, "\n";

# ˤʤƻ֥ǡåȤ2ɤߤޤϰܡ
open(FILE, $originalFileName) || die "$originalFileName : $!";

# üθĿ
$numOfEndPoints = 0;

# ƻʬθĿ
$numOfRiverSegments = 0;

# ƻʬֹ
$iSeg = 0;

# ƻʬν 1, ƻʬΤϤޤޤ 0
$startSegFlag = 1;

# ϿޤϰϤե饰
$xyFlag = 0;

while(<FILE>)
{
  if (/^#/)
  {
    # ȹԤɤФ
    next;
  }
  if (/^\n/)
  {
    # ԤɤФ
    next;
  }
  @list = split(' ', $_);

  # Ͻɤ߹ߤޤ̵뤷ޤ
  $iEndPoint = $list[2];
  if ($iEndPoint < 0)
  {
    $iEndPoint = -$iEndPoint;
  }

  # üä ...
  if ($iEndPoint > 0)
  {
    $rEndPoint[$iEndPoint] = 1;
    $xEndPoint[$iEndPoint] = $list[3];
    $yEndPoint[$iEndPoint] = $list[4];
    $zEndPoint[$iEndPoint] = $list[5];
    if ($iEndPoint > $numOfEndPoints)
    {
      $numOfEndPoints = $iEndPoint;
    }
  }

  # ƻʬ
  if ($startSegFlag != 0)
  {
    # ƻʬΤϤޤ
    $iSeg++;
    $startSegFlag = 0;
  }
  else
  {
    # ƻʬ
    if ($iEndPoint > 0)
    {
      # ƻʬä
      $startSegFlag = 1;
    }
  }

  # ɸϰϤϿ
  if ($xyFlag == 0)
  {
    # ǽΥǡ
    $xmin = $list[3];
    $xmax = $list[3];
    $ymin = $list[4];
    $ymax = $list[4];
    $xyFlag = 1;
  }
  else
  {
    # ɸϰϤι
    if ($list[3] < $xmin)
    {
      $xmin = $list[3];
    }
    if ($list[3] > $xmax)
    {
      $xmax = $list[3];
    }
    if ($list[4] < $ymin)
    {
      $ymin = $list[4];
    }
    if ($list[4] > $ymax)
    {
      $ymax = $list[4];
    }
  }
}

# ɸϰϤ񤭽Фơ桼ǡϤΤ
print "Input Coorners of the Map: \n";
print "X was bounded within from $xmin to $xmax\n";
print "Y was bounded within from $ymin to $ymax\n";
print "Input (x, y, z) of the Lower Left corner point: ";
chomp($line = <STDIN>);
@list = split(' ', $line);
$xCorner[0] = $list[0];
$yCorner[0] = $list[1];
$zCorner[0] = $list[2];
print "Input (x, y, z) of the Lower Right corner point: ";
chomp($line = <STDIN>);
@list = split(' ', $line);
$xCorner[1] = $list[0];
$yCorner[1] = $list[1];
$zCorner[1] = $list[2];
print "Input (x, y, z) of the Upper Right corner point: ";
chomp($line = <STDIN>);
@list = split(' ', $line);
$xCorner[2] = $list[0];
$yCorner[2] = $list[1];
$zCorner[2] = $list[2];
print "Input (x, y, z) of the Upper Left corner point: ";
chomp($line = <STDIN>);
@list = split(' ', $line);
$xCorner[3] = $list[0];
$yCorner[3] = $list[1];
$zCorner[3] = $list[2];

print OFILE "[Vertices of the Map]\n";
for $i (0..3)
{
  print OFILE $xCorner[$i], " ", $yCorner[$i], " ", $zCorner[$i],
        "\n";
}

$i = 1; $j = 0;
while ($i <= $numOfEndPoints)
{
  if ($rEndPoint[$i] == 1) {
    $j++;
  }
  $i++;
}
$j;

print OFILE "[Number of End Points]\n", $j, "\n";
print OFILE "[Data of End Points]\n";

$i = 1;
while ($i <= $numOfEndPoints)
{
  if ($rEndPoint[$i] == 1) {
    print OFILE $i, " ", $xEndPoint[$i], " ", $yEndPoint[$i], " ",
                 $zEndPoint[$i], "\n";
  }
  $i++;
}

print OFILE "[Number of River Segments]\n";
print OFILE $iSeg, "\n";

close(FILE);
open(FILE, $originalFileName) || die "$originalFileName : $!";

print OFILE "[Data]\n";

# ƻʬθĿ
$numOfRiverSegments = 0;

# ƻʬֹ
$iSeg = 0;

# ƻʬν 1, ƻʬΤϤޤޤ 0
$startSegFlag = 1;

while(<FILE>)
{
  if (/^#/)
  {
    # ȹԤɤФ
    next;
  }
  if (/^\n/)
  {
    # ԤɤФ
    next;
  }
  @list = split(' ', $_);
  $iEndPoint = $list[2];
  if ($iEndPoint < 0)
  {
    $iEndPoint = -$iEndPoint;
  }
  if ($iEndPoint > 0)
  {
    $rEndPoint[$iEndPoint] = 1;
    $xEndPoint[$iEndPoint] = $list[3];
    $yEndPoint[$iEndPoint] = $list[4];
    $zEndPoint[$iEndPoint] = $list[5];
    if ($iEndPoint > $numOfEndPoints)
    {
      $numOfEndPoints = $iEndPoint;
    }
  }
  if ($startSegFlag != 0)
  {
    # ƻʬΤϤޤ
    $iSeg++;
    $startSegFlag = 0;
  }
  else
  {
    # ƻʬ
    if ($iEndPoint > 0)
    {
      # ƻʬä
      $startSegFlag = 1;
    }
  }
  $infoPosition = 0;  # ޳üή
  if ($iEndPoint == 0)
  {
    # ü
    $infoPosition = -1;
  }
  print OFILE $xMap, " ", $yMap,
        " ", $list[2], " ", $list[3], " ", $list[4],
        " ", $list[5],
        " ", $iSeg, " ", $infoPosition, "\n";
}

close(FIlE);
close(OFILE);

## Local Variables: ***
## mode: Text ***
## End: ***


